﻿init python:
    import pygame
    class movement:
        def __init__(self):

            self.direction = "down"
            self.stat = "idle"
        def walk(self, direction):
            self.direction = direction
            self.stat = "walk"
            
            coll =  None # self.collide(person, direction)
            if not coll:
                self.move(direction)
        def move(self, direction):
            if direction == "up":
                self.y -= 1
            elif direction == "left":
                self.x -= 1
            elif direction == "down":
                self.y += 1
            elif direction == "right":
                self.x += 1
    class leveling:
        def __init__(self, level):
            self.level = level
            self.exp = 0
        def got_exp(self, amount):
            self.exp += amount
            if self.exp > 99:
                self.exp -= 100
                self.level_up()
        def level_up(self):
            self.level += 1
            Play("sound", "audio/level_up.ogg")()
    class loot:
        def __init__(self, table = [], cash = 0):
            self.table = table
            self.cash = cash

    def drop_loot(table):
        sum1 = 0
        for i in table:
            sum1 += i[1]
        r = renpy.random.randint(1,sum1)
        sum2 = 0
        for i in table:
            sum2 += i[1]
            if r < sum2:
                return i[0]

    def drop_more(table, n):
        loot = []
        for i in range(n):
            item = drop_loot(table)
            if not item == None:
                loot.append(item)
        return loot


    class actor:
        def __init__(self, name, x, y, portrait):
            self.name = name
            self.max_hp = 100
            self.hp = 100
            self.max_food = 100
            self.food = 100
            self.portrait = portrait
            self.placed = False

            self.attack = 2
            self.armor = 2

            self.alpha = 0
            self.x = 0
            self.y = 0
            self.direction = "down"
            self.stat = "idle"
            self.busy = 0
            self.locked = False
            self.hidden = False
        def face(self, target, away = False, ret = False):
            x = self.x -target.x
            y = self.y - target.y
            if away:
                x = -x
                y = -y
            if abs(x) > abs(y):
                if x > 0:
                    direction = "left"
                else:
                    direction = "right"
            else:
                if y > 0:
                    direction = "up"
                else:
                    direction = "down"
            if ret:
                return direction
            else:
                self.direction = direction
        def tick(self):
            if not self.stat == "dead":
                if self.busy > 0:
                    self.busy -= 1
                if self.busy < 1:
                    self.stat = "idle"
        def unlock(self):
            self.locked = False
    class equip:
        def __init__(self):
            self.total_attack = 0
            self.total_armor = 0
            self.equipment = {
                "left" : [],
                "hands" : [],
                "head" : [],
                "neck" : [],
                "right" : [],

                "fingers" : [],
                "feet" : [],
                "chest" : [],
                "quick_2" : [],
                "bag" : [],
            }
            self.calculate_equipment()

        def calculate_equipment(self):
            attack = 0
            armor = 0
            for j in self.equipment:
                for i in self.equipment[j]:
                    if isinstance(i, equipment):
                        attack += i.attack
                        armor += i.armor
            self.total_attack = attack + self.attack
            self.total_armor = armor + self.armor
            renpy.restart_interaction()

        def item_equip(self, item, slot):

            if len(self.equipment[slot]):
                taken = self.equipment[slot].pop()
                self.add_item([taken, 1])

            self.equipment[slot].append(item)
            self.remove_item([item, 1])
            self.calculate_equipment()

        def get_filtered_items(self, filter):
            items = []
            for i in range(self.current_bag[0], self.current_bag[1]):
                if self.items[i] and filter in self.items[i].item.tags:
                    items.append(self.items[i])
            
            Show("select_item", items = items, inv = self, filter = filter)()

    class player_unit(actor, equip, inventory_class, leveling):
        def __init__(self, name, x, y, level = 1, portrait = "no_portrait"):
            actor.__init__(self, name, x, y, portrait)
            equip.__init__(self)
            inventory_class.__init__(self, cash = 0, items = [], markup = 1.0, bags = [[42, "Backpack"], [4, "Pockets"]])
            leveling.__init__(self, level)
            self.deadly_level = 1

    def enemy_level_up(enemy):
        for i in range(enemy.level):
            enemy.total_armor += renpy.random.randint(2,6)
            enemy.total_attack += renpy.random.randint(2,6)

    class enemy_unit(actor, loot):
        def __init__(self, name, x, y, level = 1, portrait = "no_portrait", table = [], attack = 1, armor = 1):
            actor.__init__(self, name, x, y, portrait)
            loot.__init__(self, table)
            self.total_attack = attack
            self.total_armor = armor
            self.level = level
            self.exp = 0
    class npc_unit(actor, movement):
        def __init__(self, name, x, y, level = 1, portrait = "no_portrait", table = [], attack = 1, armor = 1):
            actor.__init__(self, name, x, y, portrait)
            movement.__init__(self)
            self.total_attack = attack
            self.total_armor = armor
            self.cash = 0
            self.level = level
            self.exp = 0

