﻿init python:
    from copy import copy
    def get_key():
        if event in pygame.event.get():
            if event.type == pygame.KEYDOWN:
                msg.msg("key down")
            if event.type == pygame.KEYUP:
                msg.msg("key up")
    def load_map(tilemap):
        map = []
        f = open(renpy.loader.transfn(tilemap),"r")
        for line in f:
            line = line.strip()
            divided = line.split(",")
            listed = [[x, []] for x in divided]
            map.append(listed)
        f.close()
        return map
    def load_tiles(img, size):
        tiles = []
        for i in range(8):
            for ii in range(8):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class tile:
        def __init__(self, image, type):
            self.image = image
            self.type = type

    class room_class:
        def __init__(self, name, size, map, level = 0,
            objects = [], exits = [], npc = [], enemies = []):
            self.name = name
            self.size = size
            self.set = load_tiles(map[0], size)
            self.map = load_map(map[1])
            self.level = level
            self.steps = 0
            self.exits = exits
            self.explosions = []
            self.npc = []
            for i in npc:
                i[0].x , i[0].y = i[1], i[2]
                self.npc.append(i[0])
            self.collisions = []
            for i in range(-1, 24):
                self.collisions.append(str(i))
            if objects:
                for i in objects:
                    self.map[i[1]][i[0]][1].append(i[2])
            self.enemies = []
            for i in enemies:
                if len(i) == 4:
                    self.spawn(i[0], i[1], i[2], i[3])
                else:
                    self.spawn(i[0], i[1], i[2])
            self.follower = None
        def remove_explosion(self, e):
            self.explosions.remove(e)
        def has_object(self, object):
            for i in self.map:
                for j in i:
                    if len(j[1]):
                        for k in j[1]:
                            if k == object:
                                return True
            else:
                return False

        def collide(self, actor, direction, x = 0, y = 0):
            if actor:
                x = actor.x
                y = actor.y
                if direction == "up":
                    y -= 1
                elif direction == "left":
                    x -= 1
                elif direction == "down":
                    y += 1
                elif direction == "right":
                    x += 1
            if y < 0 or y > len(self.map)-1:
                return "wall"
            if hero.y == y:
                if hero.x == x:
                    return "player"
            for i in self.enemies:
                if i.y == y:
                    if i.x == x:
                        if not i.stat == "dead":
                            return "enemy", i
            # for i in self.enemies:
            #     if i.y == y:
            #         if i.x == x:
            #             if i.stat == "dead":
            #                 return "dead enemy", i
            for i in self.npc:
                if not i.hidden:
                    if i.y == y:
                        if i.x == x:
                            return "npc", i
            if self.map[y][x][0] in self.collisions:
                return "wall"
            else:
                return False
        def spawn_at_random(self, enemy, manual = False):
            self.steps = 0
            if self.level > 0 or manual:
                for i in range(100):
                    x = renpy.random.randint(0, len(self.map[0])-1)
                    y = renpy.random.randint(0, len(self.map)-1)
                    if not self.collide(None, None, x, y):
                        self.spawn(enemy, x, y)
                        self.explosions.append([x*self.size, y*self.size])
                        Play("sound", "audio/explosion.ogg")()
                        break
        
        def spawn(self, enemy, x = None, y = None, hp = None, food = None):
            enemy = copy(enemy)
            enemy.x = x
            enemy.y = y
            enemy.level = self.level + renpy.random.randint(-1, 1)
            enemy_level_up(enemy)
            if hp != None:
                enemy.hp = hp
            if food != None:
                enemy.food = food
            else:
                enemy.food = renpy.random.randint(2, 100)
            self.enemies.append(enemy)


        # Tests
        def kill_enemy(self):
            for i in self.enemies:
                i.stat = "dead"
        def give_hp(self):
            hero.hp += 1000
        # Tests

        def take(self):
            if len(self.map[hero.y][hero.x][1]):
                it = self.map[hero.y][hero.x][1].pop()
                hero.got(True, it, 1)

        def move(self, direction):
            if renpy.get_screen("say") or renpy.get_screen("choice"):
                return
            if not hero.stat == "dead":
                if self.follower: # follower
                    heros_direction = self.follower.face(hero, False, True)
                hero.direction = direction
                hero.busy = 10
                hero.locked = True
                hero.stat = "walk"

                coll = self.collide(hero, direction)
                if coll:
                    if coll[0] == "npc":
                        self.talk(coll[1])
                    elif coll[0] == "enemy":
                        self.attack(hero, coll[1])
                        Play("sound", "audio/hit.ogg")()
                else:
                    self.go(hero, direction)
                    x = hero.x
                    y = hero.y
                    for i in self.exits:
                        if i[0] == x and i[1] == y:
                            Show("level_change", g = self, exit = i)()
                    
                    self.steps += 1

                    if self.follower: # follower
                        self.go(self.follower, heros_direction)


                    if hero.hp < hero.max_hp and hero.food > 0:
                        if self.level == 0:
                            hero.hp += 3
                        else:
                            hero.hp += 1
                        if hero.hp > hero.max_hp:
                            hero.hp = hero.max_hp
                        hero.food -= 1
                    if hero.food < 1:
                        hero.hp -= 1
                        Play("sound", "audio/hurt.ogg")()
                        if hero.hp < 1:
                            hero.stat = "dead"

                self.enemies_turn()

        def enter_level(self, exit):
            Hide("level")()
            level = eval(exit[2])

            for i in level.exits:
                if i[3] == exit[3]:
                    doorway = i
                    hero.x, hero.y = i[0], i[1]
                    break
            Show("level", g = level, direction = doorway[4])()
            # hero.x, hero.y = level.exits[exit[3]][0], level.exits[exit[3]][1]
            t = []
            for i in level.enemies:
                if not i.stat == "dead":
                    t.append(i)
            level.enemies = t
            for i in level.enemies:
                if i.hp < 1:
                    i.direction = renpy.random.choice(["left", "right"])
                    i.stat = "dead"
        def go(self, actor, direction):
            if direction == "up":
                actor.y -= 1
            elif direction == "left":
                actor.x -= 1
            elif direction == "down":
                actor.y += 1
            elif direction == "right":
                actor.x += 1
        def talk(self, actor):
            actor.face(hero)
            Call(actor.name.lower())()
        def attack(self, attacker, target):
            global talking_to
            attacker.stat = "attack"
            if attacker == hero:
                talking_to = target
            else:
                talking_to = attacker
            crit = renpy.random.randint(-2, 2)
            damage = (attacker.total_attack + crit) - target.armor
            if damage < 1:
                damage = 1
            target.hp -= damage
            if target.hp < 1:
                target.stat = "dead"
                if not target == hero: # Drop loot
                    loot = drop_more(target.table, renpy.random.randint(0, 4))
                    for i in loot:
                        self.map[target.y][target.x][1].append(i)
                    # give exp
                    exp = 8 - (hero.level - target.level)
                    if exp < 1:
                        exp = 1
                    hero.got_exp(exp)
                    if hero.deadly_level <= target.level:
                        hero.deadly_level = target.level+1

        def walk(self, person, direction):
            person.direction = direction
            person.busy = 10
            person.locked = True
            person.stat = "walk"
            
            coll =  self.collide(person, direction)
            if not coll or coll[0] == "dead enemy":
                self.go(person, direction)

        def enemies_turn(self):
            for i in self.enemies:
                i.placed = True
                if not i.stat == "dead":
                    direction = i.face(hero, False, True)
                    coll = self.collide(i, direction)
                    if not coll or coll[0] == "dead enemy":
                        self.walk(i, direction)
                    elif coll == "player":
                        i.direction = direction
                        self.attack(i, hero)
                        if not renpy.music.is_playing("sound"):
                            Play("sound", "audio/hurt.ogg")()
                    elif coll:
                        direction = renpy.random.choice(["up", "left", "down", "right"])
                        self.walk(i, direction)


image enter_explosion:
    Crop((0, 0, 32, 32), "explosion")
    pause .05
    Crop((32, 0, 32, 32), "explosion")
    pause .05
    Crop((64, 0, 32, 32), "explosion")
    pause .05
    Crop((96, 0, 32, 32), "explosion")
    pause .05
    Crop((128, 0, 32, 32), "explosion")
    pause .05
    Crop((160, 0, 32, 32), "explosion")
    pause .05
    Crop((192, 0, 32, 32), "explosion")

transform level_change_fade:
    alpha 0
    ease .2 alpha 1
    pause .5
    ease .2 alpha 0
screen level_change(g, exit):
    # modal True
    zorder -1
    add "loading" at level_change_fade
    timer .2 action Function(g.enter_level, exit = exit)
    timer .9 action Hide("level_change")
screen level(g, direction):
    zorder -2

    timer .5 action Function(g.move, direction)
    default scale = 2.0

    if g.steps > 30:
        timer .1 action Function(g.spawn_at_random, renpy.random.choice(all_enemies))
    frame:
        ysize 860 yalign .0 background None
        fixed:
            fit_first True
            at zoom(scale)
            vbox:
                spacing 0
                for ii in g.map:
                    hbox:
                        spacing 0
                        for i in ii:
                            if i[0] == "-1":
                                frame:
                                    background None xysize(g.size,g.size)
                            else:
                                frame:
                                    background g.set[int(i[0])]
                                    xysize(g.size,g.size)
                                    if len(i[1]):
                                        add i[1][0].icon align .5,.5 at zoom(.5)
            for i in g.npc:
                frame:
                    xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                    if not i.hidden:
                        fixed:
                            add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8
                            if i.hp < i.max_hp and not i.stat == "dead":
                                bar xysize 23,2 value i.hp range i.max_hp yoffset -30 left_bar "#b00" right_bar "#fff"
            for i in g.enemies:
                frame:
                    xysize(g.size, g.size) background None align .0,.0
                    if i.placed:
                        at player_move(i.x*g.size, i.y*g.size)
                    else:
                        at player_move(i.x*g.size, i.y*g.size, .0)
                    fixed:
                        add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8
                        vbox:
                            yoffset -30
                            if i.level >= hero.deadly_level and i.level > hero.level:
                                add "deadly_enemy"
                            # else:
                            #     text str(i.level) size 10
                            if i.hp < i.max_hp and not i.stat == "dead":
                                bar xysize 23,2 value i.hp range i.max_hp left_bar "#b00" right_bar "#fff"
            for i in g.explosions:
                add "enter_explosion" pos i[0],i[1] anchor .0,.0
                timer .3 action Function(g.remove_explosion, i)
            frame:
                xysize(g.size, g.size) background None at player_move(hero.x*g.size, hero.y*g.size) align .0,.0
                fixed:
                    add "{} {} {}".format(hero.name, hero.direction, hero.stat) align(.5,.5) yoffset -8
                    if hero.hp < hero.max_hp and not hero.stat == "dead":
                        bar xysize 23,2 value hero.hp range hero.max_hp yoffset -30 left_bar "#b00" right_bar "#fff"
    default enter_pause = True
    timer .8 action SetScreenVariable("enter_pause", False)
    if hero.busy > 0:
        timer .06 repeat True action Function(hero.tick)
    if hero.locked:
        timer .32 repeat True action Function(hero.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    elif not enter_pause:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")
        key "repeat_w" action Function(g.move, "up")
        key "repeat_a" action Function(g.move, "left")
        key "repeat_s" action Function(g.move, "down")
        key "repeat_d" action Function(g.move, "right")
    key "e" action Function(g.take)

    if hero.stat == "dead":
        button:
            background "#000a"
            action NullAction()
        frame:
            yalign .4
            vbox:
                text _("You have died.")
                hbox:
                    button:
                        text _("Load")
                        action ShowMenu("load")
                    button:
                        text _("Main menu")
                        action MainMenu()


    ###### Change name
    default edit_name = False
    vbox:
        align .0,.0
        if edit_name:
            frame:
                input xysize 300,40 value FieldInputValue(g, "name")
            button:
                text _("Done")
                action SetScreenVariable("edit_name", False)
        else:
            button:
                text g.name
                action SetScreenVariable("edit_name", True)

    ###### Test stuff
    hbox:
        align .5,.0 spacing 10
        bar value ScreenVariableValue("scale", 3.0, offset=1.0) xysize 500,40
        button:
            ysize 40 xpadding 10
            text "reset" align .5,.5
            action SetScreenVariable("scale", 2.0)
    
    vbox:
        align .1,.0
        text "{}   {},{}    {}   {}".format(g.level, hero.x, hero.y, g.steps, hero.deadly_level) color "#ffd"

    drag:
        align .99,.4
        frame:
            vbox:
                spacing 10
                text "Tests"
                button:
                    text "Spawn"
                    action Function(g.spawn_at_random, renpy.random.choice(all_enemies), True)
                button:
                    text "Face"
                    action Function(thora.face, hero)
                button:
                    text "Face way"
                    action Function(thora.face, hero, True)
                button:
                    text "Kill all"
                    action Function(g.kill_enemy)
                button:
                    text "+10 exp"
                    action Function(hero.got_exp, 10)
                button:
                    text "Give hp"
                    action Function(g.give_hp)




transform player_move(x, y, t = .45):
    # subpixel True
    linear t xpos x ypos y

