﻿init python:
    class item: # Item class
        def __init__(self,
                name, info = "No description", icon = "inventory/icons/empty.png", value = 0,
                tags = [], waste = []
            ):
            self.name = name
            self.info = info
            self.icon = icon
            self.value = value
            self.tags = tags
            self.waste = waste

    class stack: # Item stack class
        def __init__(self, item, quantity):
            self.item = item
            self.quantity = quantity
        
        def sum(self): # Returns the total value for the items in this stack
            return self.item.value*self.quantity




    class food(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                food = 0, water = 0,
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.food = food
            self.water = water

    class book(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                text = [],
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.text = text

    class equipment(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                weight = 0,
                attack = 0, armor = 0,
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.weight = weight
            self.attack = attack
            self.armor = armor

    class furniture(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
            ):
            item.__init__(self, name, info, icon, value, tags, waste)

init python:
    config.underlay.append(
        renpy.Keymap(
            K_BACKQUOTE=lambda: renpy.run(ToggleScreen("loot_table_generator_2"))
        )
    )
screen loot_table_generator():
    hbox:
        xalign .0
        vbox:
            default weapons = []
            hbox:
                xalign .0
                button:
                    text _("Add weapon")
                    action AddToSet(weapons, renpy.random.choice(all_weapons))
                for i in weapons:
                    button:
                        add i.icon
                        action RemoveFromSet(weapons, i)
            default shields = []
            hbox:
                xalign .0
                button:
                    text _("Add shield")
                    action AddToSet(shields, renpy.random.choice(all_shields))
                for i in shields:
                    button:
                        add i.icon
                        action RemoveFromSet(shields, i)
            default helmets = []
            hbox:
                xalign .0
                button:
                    text _("Add helmet")
                    action AddToSet(helmets, renpy.random.choice(all_helmets))
                for i in helmets:
                    button:
                        add i.icon
                        action RemoveFromSet(helmets, i)
            default gloves = []
            hbox:
                xalign .0
                button:
                    text _("Add glove")
                    action AddToSet(gloves, renpy.random.choice(all_gloves))
                for i in gloves:
                    button:
                        add i.icon
                        action RemoveFromSet(gloves, i)
            default shoes = []
            hbox:
                xalign .0
                button:
                    text _("Add shoe")
                    action AddToSet(shoes, renpy.random.choice(all_shoes))
                for i in shoes:
                    button:
                        add i.icon
                        action RemoveFromSet(shoes, i)
            default chests = []
            hbox:
                xalign .0
                button:
                    text _("Add chest")
                    action AddToSet(chests, renpy.random.choice(all_chests))
                for i in chests:
                    button:
                        add i.icon
                        action RemoveFromSet(chests, i)
            default foods = []
            hbox:
                xalign .0
                button:
                    text _("Add food")
                    action AddToSet(foods, renpy.random.choice(all_foods))
                for i in foods:
                    button:
                        add i.icon
                        action RemoveFromSet(foods, i)
            default drinks = []
            hbox:
                xalign .0
                button:
                    text _("Add drink")
                    action AddToSet(drinks, renpy.random.choice(all_drinks))
                for i in drinks:
                    button:
                        add i.icon
                        action RemoveFromSet(drinks, i)
            default sweets = []
            hbox:
                xalign .0
                button:
                    text _("Add sweet")
                    action AddToSet(sweets, renpy.random.choice(all_sweets))
                for i in sweets:
                    button:
                        add i.icon
                        action RemoveFromSet(sweets, i)
        button:
            text _("Clear")
            action [SetScreenVariable("weapons", []), SetScreenVariable("shields", []),
                    SetScreenVariable("helmets", []), SetScreenVariable("gloves", []),
                    SetScreenVariable("shoes", []), SetScreenVariable("chests", []),
                    SetScreenVariable("foods", []), SetScreenVariable("drinks", []),
                    SetScreenVariable("sweets", [])
                ]
        button:
            text _("Copy")
            action Function(clip_put, copy_loot_table(weapons + shields + helmets + gloves + shoes + chests + foods + drinks + sweets))

screen loot_table_generator_2():
    modal True
    add "#000e"
    vbox:
        xalign .0
        hbox:
            box_wrap True xalign .0
            default weapons = []
            for i in all_weapons:
                button:
                    add i.icon
                    action If(i in weapons, RemoveFromSet(weapons, i), AddToSet(weapons, i)), SelectedIf(i in weapons)
        hbox:
            box_wrap True xalign .0
            default shields = []
            for i in all_shields:
                button:
                    add i.icon
                    action If(i in shields, RemoveFromSet(shields, i), AddToSet(shields, i)), SelectedIf(i in shields)
        hbox:
            box_wrap True xalign .0
            default chests = []
            for i in all_chests:
                button:
                    add i.icon
                    action If(i in chests, RemoveFromSet(chests, i), AddToSet(chests, i)), SelectedIf(i in chests)
        hbox:
            box_wrap True xalign .0
            default helmets = []
            for i in all_helmets:
                button:
                    add i.icon
                    action If(i in helmets, RemoveFromSet(helmets, i), AddToSet(helmets, i)), SelectedIf(i in helmets)
        hbox:
            box_wrap True xalign .0
            default gloves = []
            for i in all_gloves:
                button:
                    add i.icon
                    action If(i in gloves, RemoveFromSet(gloves, i), AddToSet(gloves, i)), SelectedIf(i in gloves)
        hbox:
            box_wrap True xalign .0
            default shoes = []
            for i in all_shoes:
                button:
                    add i.icon
                    action If(i in shoes, RemoveFromSet(shoes, i), AddToSet(shoes, i)), SelectedIf(i in shoes)

        hbox:
            box_wrap True xalign .0
            default foods = []
            for i in all_foods:
                button:
                    add i.icon
                    action If(i in foods, RemoveFromSet(foods, i), AddToSet(foods, i)), SelectedIf(i in foods)
        hbox:
            box_wrap True xalign .0
            default drinks = []
            for i in all_drinks:
                button:
                    add i.icon
                    action If(i in drinks, RemoveFromSet(drinks, i), AddToSet(drinks, i)), SelectedIf(i in drinks)
        hbox:
            box_wrap True xalign .0
            default sweets = []
            for i in all_sweets:
                button:
                    add i.icon
                    action If(i in sweets, RemoveFromSet(sweets, i), AddToSet(sweets, i)), SelectedIf(i in sweets)
    hbox:
        align .5,1.0
        button:
            text _("Clear")
            action [SetScreenVariable("weapons", []), SetScreenVariable("shields", []),
                    SetScreenVariable("helmets", []), SetScreenVariable("gloves", []),
                    SetScreenVariable("shoes", []), SetScreenVariable("chests", []),
                    SetScreenVariable("foods", []), SetScreenVariable("drinks", []),
                    SetScreenVariable("sweets", [])
                ]
        button:
            text _("Copy")
            action Function(clip_put, copy_loot_table(weapons + shields + chests + helmets + gloves + shoes + foods + drinks + sweets))


init python:
    def copy_loot_table(m):
        r = ""
        for i in m:
            r += "["
            r += variablename(i)[0]
            r += ", 1],\n"
        return r
    def variablename(var):
        import itertools
        return [tpl[0] for tpl in itertools.ifilter(lambda x: var is x[1], globals().items())]



# ------ chest
default bronze_chestplate = equipment(
    _("Bronze chestplate"),
    _("Looks flimsy."),
    "bronze_chestplate",
    400,
    ["chest"],
    [],
    8,
    armor = 2
)
default iron_chestplate = equipment(
    _("Iron chestplate"),
    _("Looks sturdy."),
    "iron_chestplate",
    800,
    ["chest"],
    [],
    7,
    armor = 4
)
default engraved_chestplate = equipment(
    _("Engraved chestplate"),
    _("Looks pretty."),
    "engraved_chestplate",
    1000,
    ["chest"],
    [],
    7,
    armor = 3
)
default steel_chestplate = equipment(
    _("Steel chestplate"),
    _("Looks impenetrable."),
    "steel_chestplate",
    1200,
    ["chest"],
    [],
    9,
    armor = 7
)
default ancient_armor = equipment(
    _("Ancient armor"),
    _("Looks Fantastic."),
    "ancient_armor",
    2200,
    ["chest"],
    [],
    9,
    armor = 5
)

default all_chests = [
    bronze_chestplate, iron_chestplate, engraved_chestplate, steel_chestplate,
    ancient_armor
]
# ------ Feet
default iron_shoes = equipment(
    _("Iron shoes"),
    _("Very uncomfortable."),
    "iron_shoes",
    600,
    ["feet"],
    [],
    2,
    armor = 2
)
default leather_shoes = equipment(
    _("Leather shoes"),
    _("Sturdy."),
    "leather_shoes",
    1600,
    ["feet"],
    [],
    1,
    armor = 1
)

default all_shoes = [
    iron_shoes, leather_shoes
]
# ------ hands
default golden_gloves = equipment(
    _("Golden gloves"),
    _("Very uncomfortable."),
    "golden_gloves",
    600,
    ["hands"],
    [],
    2,
    armor = 2
)
default half_gloves = equipment(
    _("Half gloves"),
    _("Very uncomfortable."),
    "half_gloves",
    400,
    ["hands"],
    [],
    1,
    armor = 1
)
default royal_gloves = equipment(
    _("Royal gloves"),
    _("Very uncomfortable."),
    "royal_gloves",
    1400,
    ["hands"],
    [],
    2,
    armor = 4
)

default all_gloves = [
    golden_gloves, half_gloves, royal_gloves
]
# ------ head
default bronze_helmet = equipment(
    _("Bronze helmet"),
    _("Very uncomfortable."),
    "bronze_helmet",
    600,
    ["head"],
    [],
    4,
    armor = 3
)
default engraved_helmet = equipment(
    _("Engraved helmet"),
    _("Very uncomfortable."),
    "engraved_helmet",
    600,
    ["head"],
    [],
    4,
    armor = 5
)
default golden_helmet = equipment(
    _("Golden helmet"),
    _("Very uncomfortable."),
    "golden_helmet",
    600,
    ["head"],
    [],
    4,
    armor = 4
)
default horny_hood = equipment(
    _("Horny hood"),
    _("Very uncomfortable."),
    "horny_hood",
    600,
    ["head"],
    [],
    2,
    armor = 6
)
default rain_collector_helmet = equipment(
    _("Rain collector helmet"),
    _("Very uncomfortable."),
    "rain_collector_helmet",
    600,
    ["head"],
    [],
    2,
    armor = 7
)
default royal_helmet = equipment(
    _("Royal helmet"),
    _("Very uncomfortable."),
    "royal_helmet",
    600,
    ["head"],
    [],
    2,
    armor = 6
)
default rusty_helmet = equipment(
    _("Rusty helmet"),
    _("Very uncomfortable."),
    "rusty_helmet",
    600,
    ["head"],
    [],
    2,
    armor = 4
)

default all_helmets = [
    bronze_helmet, engraved_helmet, golden_helmet, horny_hood, rain_collector_helmet,
    royal_helmet, rusty_helmet
]
# ------ Shield
default dual_lion_shield = equipment(
    _("Dual lion shield"),
    _("Very uncomfortable."),
    "dual_lion_shield",
    600,
    ["shield", "left", "right"],
    [],
    4,
    armor = 12
)
default lion_shield = equipment(
    _("Lion shield"),
    _("Very uncomfortable."),
    "lion_shield",
    600,
    ["shield", "left", "right"],
    [],
    4,
    armor = 10
)
default round_shield = equipment(
    _("Round shield"),
    _("Very uncomfortable."),
    "round_shield",
    600,
    ["shield", "left", "right"],
    [],
    4,
    armor = 8
)
default sun_shield = equipment(
    _("Sun shield"),
    _("Very uncomfortable."),
    "sun_shield",
    600,
    ["shield", "left", "right"],
    [],
    4,
    armor = 9
)
default wall_shield = equipment(
    _("Wall shield"),
    _("Very uncomfortable."),
    "wall_shield",
    600,
    ["shield", "left", "right"],
    [],
    4,
    armor = 18
)

default all_shields = [
    dual_lion_shield, lion_shield, round_shield, sun_shield, wall_shield
]

# ------ weapon
default axe = equipment(
    _("Axe"),
    _("Very uncomfortable."),
    "axe",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 8
)
default blade_mace = equipment(
    _("Blade mace"),
    _("Very uncomfortable."),
    "blade_mace",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 12
)
default curvy_dagger = equipment(
    _("Curvy dagger"),
    _("Very uncomfortable."),
    "curvy_dagger",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 9
)
default dual_axe = equipment(
    _("Dual axe"),
    _("Very uncomfortable."),
    "dual_axe",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 8
)
default katana = equipment(
    _("Katana"),
    _("Very uncomfortable."),
    "katana",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 15
)
default long_dagger = equipment(
    _("Long dagger"),
    _("Very uncomfortable."),
    "long_dagger",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 7
)
default rough_sword = equipment(
    _("Rough sword"),
    _("Very uncomfortable."),
    "rough_sword",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 11
)
default short_sword = equipment(
    _("Short sword"),
    _("Very uncomfortable."),
    "short_sword",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 9
)
default spiked_stick = equipment(
    _("Spiked stick"),
    _("Very uncomfortable."),
    "spiked_stick",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 7
)
default wavy_dagger = equipment(
    _("Wavy dagger"),
    _("Very uncomfortable."),
    "wavy_dagger",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 6
)
default wooden_hammer = equipment(
    _("Wooden hammer"),
    _("Very uncomfortable."),
    "wooden_hammer",
    600,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 6
)
default scythe = equipment(
    _("Scythe"),
    _("Scary but clunky."),
    "scythe",
    400,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 5
)
default hatchet = equipment(
    _("Hatchet"),
    _("Good for woodworking."),
    "hatchet",
    400,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 5
)
default red_handshake_dagger = equipment(
    _("Red handshake dagger"),
    _("Looks cursed."),
    "red_handshake_dagger",
    400,
    ["weapon", "left", "right"],
    [],
    4,
    attack = 5
)

default all_weapons = [
    axe, dual_axe, hatchet,
    blade_mace, 
    curvy_dagger, long_dagger, wavy_dagger,
    katana, rough_sword, short_sword, 
    spiked_stick, wooden_hammer, scythe, 
]
# Foods
default bread = food(
    _("Bread"),
    _("A bit stale."),
    "bread",
    10,
    ["food"],
    [],
    food = 60,
    water = -10,
)
default cheese = food(
    _("Cheese"),
    _("Smells strong."),
    "cheese",
    10,
    ["food"],
    [],
    food = 50,
    water = 5,
)
default raw_meat = food(
    _("Raw meat"),
    _("Looks like cow's meat."),
    "raw_meat",
    10,
    ["food", "meat", "raw"],
    [],
    food = 40,
    water = 0,
)
default spiky_fruit = food(
    _("Spiky fruit"),
    _("It doesn't taste as bad as it looks."),
    "spiky_fruit",
    10,
    ["food"],
    [],
    food = 45,
    water = 20,
)

default all_foods = [
    bread, cheese, raw_meat, spiky_fruit
]
# Drinks
default fizzy_drink = food(
    _("Fizzy drink"),
    _("Smells strong."),
    "fizzy_drink",
    10,
    ["food"],
    [],
    food = 20,
    water = 60,
)
default liquor = food(
    _("Liquor"),
    _("Mostly alcohol."),
    "liquor",
    10,
    ["food"],
    [],
    food = 15,
    water = 20,
)
default medicine = food(
    _("Medicine"),
    _("It knocks you out in minutes."),
    "medicine",
    10,
    ["food"],
    [],
    food = 15,
    water = 20,
)
default vintage_wine = food(
    _("Vintage wine"),
    _("Looks very old."),
    "vintage_wine",
    70,
    ["food", "alcohol"],
    [],
    food = 30,
    water = 30,
)
default all_drinks = [
    fizzy_drink, liquor, medicine, vintage_wine
]
# Sweets
default moon_cake = food(
    _("Moon cake"),
    _("Sweet with melty core."),
    "moon_cake",
    10,
    ["food", "sweets"],
    [],
    food = 80,
    water = 0,
)
default turnover = food(
    _("Turnover"),
    _("Very sweet."),
    "turnover",
    30,
    ["food", "sweets"],
    [],
    food = 74,
    water = 0,
)
default cinnamon_roll = food(
    _("Cinnamon roll"),
    _("Looks very old."),
    "cinnamon_roll",
    50,
    ["food", "sweets"],
    [],
    food = 96,
    water = 0,
)
default all_sweets = [
    moon_cake, turnover, cinnamon_roll
]


# furniture
default barrel = furniture(
    _("Barrel"),
    _("Still good."),
    "barrel",
    50,
    ["furniture", "wood", "heavy"],
    [],
)
default anvil = furniture(
    _("Anvil"),
    _("Very heavy."),
    "anvil",
    50,
    ["furniture", "iron", "heavy"],
    [],
)
default bean_bag_bed = furniture(
    _("Bean bag bed"),
    _("Can I get out of it?"),
    "bean_bag_bed",
    50,
    ["furniture", "heavy"],
    [],
)
default kid_bed = furniture(
    _("Kid bed"),
    _("Too small for me"),
    "kid_bed",
    50,
    ["furniture", "heavy"],
    [],
)
default cauldron = furniture(
    _("Cauldron"),
    _("Was a witch around here?"),
    "cauldron",
    50,
    ["furniture", "heavy"],
    [],
)
default old_cauldron = furniture(
    _("Old cauldron"),
    _("Looks ancient."),
    "old_cauldron",
    50,
    ["furniture", "heavy", "wood"],
    [],
)
default tree_trunk = furniture(
    _("Tree trunk"),
    _("Somebody carried this here."),
    "tree_trunk",
    50,
    ["furniture", "heavy"],
    [],
)

# Plants
default bitter_pad = item(
    _("Bitter pad"),
    _("Not edible but disinfects wounds pretty good."),
    "bitter_pad",
    50,
    ["plant"],
)
default spark_finger = item(
    _("Spark finger"),
    _("Doesn't taste good, but edible."),
    "spark_finger",
    50,
    ["plant"],
)
default violander = item(
    _("Violander"),
    _("Smells nice for a plant that grows in dark."),
    "violander",
    50,
    ["plant"],
)
default dry_violander = item(
    _("Dry violander"),
    _("Can be used as spice."),
    "dry_violander",
    50,
    ["plant"],
)
default umbred = item(
    _("Umbred"),
    _("The things I can do with these big leafs."),
    "umbred",
    50,
    ["plant"],
)
default bulgered = item(
    _("Bulgered"),
    _("Pops out of ground."),
    "bulgered",
    50,
    ["plant"],
)
default blue_shade = item(
    _("Blue shade"),
    _("Very bright."),
    "blue_shade",
    50,
    ["plant"],
)
default leaftie = item(
    _("Leaftie"),
    _("Very chewy."),
    "blue_shade",
    50,
    ["leaftie"],
)

default all_plants = [bitter_pad, spark_finger, violander, dry_violander, umbred, bulgered, blue_shade, leaftie]
# Other
default wood = item(
    _("Wood"),
    _("Good quality firewood."),
    "wood",
    50,
    ["wood"],
)





